/* Parallel Hierarchical Grid -- an adaptive finite element library.
 *
 * Copyright (C) 2005-2009 State Key Laboratory of Scientific and
 * Engineering Computing, Chinese Academy of Sciences. */

/* This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA  02110-1301  USA */

/* $Id: perf.h,v 1.9 2008/12/10 06:41:18 zlb Exp $ */

#ifndef PHG_PERF_H

#ifdef __cplusplus
extern "C" {
#endif

void phgMemoryUsageReset(void);
size_t phgMemoryUsage(GRID *g, size_t *peak);
size_t phgMemoryPeakReset(size_t value);
size_t phgMemoryPeakRestore(size_t value);
void phgTimerInit(BOOLEAN init);
void phgTimerReset(void);

void phgPerfInit(void);
void phgPerfFinalize(void);
double phgPerfGetMflops(GRID *g, double *aggregate, double *since_last_call);

#ifdef __cplusplus
}
#endif

#define PHG_PERF_H
#endif
